Index: /branches/dev_003_CPL/NEMO/OPA_SRC/SBC/cpl_oasis3.F90
===================================================================
--- /branches/dev_003_CPL/NEMO/OPA_SRC/SBC/cpl_oasis3.F90	(revision 990)
+++ /branches/dev_003_CPL/NEMO/OPA_SRC/SBC/cpl_oasis3.F90	(revision 991)
@@ -1152,23 +303,30 @@
 
       DEALLOCATE(exfld)
-
-      if ( prism_was_initialized ) then
-
-         if ( prism_was_terminated ) then
-            print *, 'prism has already been terminated.'
-         else
-            call prism_terminate_proto ( ierror )
-            prism_was_terminated = .true.
-         endif
-
-      else
-
-         print *, 'Initialize prism before terminating it.'
-
-      endif
-
+      CALL prism_terminate_proto ( nerror )         
 
    END SUBROUTINE cpl_prism_finalize
 
+#else
+
+   !!----------------------------------------------------------------------
+   !!   Default case                                Forced Ocean/Atmosphere
+   !!----------------------------------------------------------------------
+   !!   Empty module
+   !!----------------------------------------------------------------------
+   USE in_out_manager               ! I/O manager
+   LOGICAL, PUBLIC, PARAMETER :: lk_cpl = .FALSE.   !: coupled flag
+   PUBLIC cpl_prism_init
+   PUBLIC cpl_prism_finalize
+
+CONTAINS
+
+   SUBROUTINE cpl_prism_init
+      WRITE(numout,*) 'cpl_prism_init: Error you sould not be there...'
+   END SUBROUTINE cpl_prism_init
+
+   SUBROUTINE cpl_prism_finalize
+      WRITE(numout,*) 'cpl_prism_finalize: Error you sould not be there...'
+   END SUBROUTINE cpl_prism_finalize
+
 #endif
 
Index: /branches/dev_003_CPL/NEMO/OPA_SRC/SBC/sbc_ice.F90
===================================================================
--- /branches/dev_003_CPL/NEMO/OPA_SRC/SBC/sbc_ice.F90	(revision 990)
+++ /branches/dev_003_CPL/NEMO/OPA_SRC/SBC/sbc_ice.F90	(revision 991)
@@ -17,26 +17,18 @@
    IMPLICIT NONE
    PRIVATE
-
+! variables used in forced and coupled mode
 #if defined key_lim3 
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpl) ::   qns_ice     !: non solar heat flux over ice  [W/m2]
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpl) ::   qsr_ice     !: solar heat flux over ice      [W/m2]
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpl) ::   dqns_ice    !: non solar heat flux sensibility over ice (LW+SEN+LA) [W/m2/K]
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpl) ::   tn_ice      !: ice surface temperature       [K]
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpl) ::   alb_ice     !: albedo of ice
 #else
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   qns_ice     !: non solar heat flux over ice  [W/m2]
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   qsr_ice     !: solar heat flux over ice      [W/m2]
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   dqns_ice    !: non solar heat flux sensibility over ice (LW+SEN+LA) [W/m2/K]
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   tn_ice      !: ice surface temperature       [K]
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   alb_ice     !: albedo of ice
 #endif
 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   tprecip     !: total precipitation           [Kg/m2/s]
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   sprecip     !: solid precipitation           [Kg/m2/s]
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   utaui_ice   !: u-stress over ice (I-point)   [N/m2]
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   vtaui_ice   !: v-stress over ice (I-point)   [N/m2]
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   fr1_i0      !: 1st fraction of sol. rad.  which penetrate inside the ice cover
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   fr2_i0      !: 2nd fraction of sol. rad.  which penetrate inside the ice cover
-
-#if ! defined key_coupled
-
+! Variables used only in forced mode
 # if defined key_lim3 
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpl) ::   qla_ice   !: latent flux over ice
@@ -47,15 +39,24 @@
 # endif
 
+! Variables used only in coupled mode
+#if defined key_lim3 
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpl) ::   tn_ice      !: ice surface temperature       [K]
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpl) ::   tckice      !: ice thickness
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpl) ::   tcksnw      !: oce thickness
 #else
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   tn_ice      !: ice surface temperature       [K]
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   tckice      !: ice thickness
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   tcksnw      !: oce thickness
+#endif
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   freeze      !: ice fraction
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   tprecip     !: total precipitation for ice   [Kg/m2/s]
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   sprecip     !: solid precipitation ( - sublimation in coupled mode )          [Kg/m2/s]
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   utaui_ice   !: u-stress over ice (I-point)   [N/m2]
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   vtaui_ice   !: v-stress over ice (I-point)   [N/m2]
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   fr1_i0      !: 1st fraction of sol. rad.  which penetrate inside the ice cover
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   fr2_i0      !: 2nd fraction of sol. rad.  which penetrate inside the ice cover
 
-# if defined key_lim3 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpl) ::   alb_ice   !: albedo of ice
-# else
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   alb_ice       !: albedo of ice
-# endif
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   rrunoff       !: runoff
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   calving       !: calving
-
-#endif
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   rnfcpl       !: runoff
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   ocalving     !: calving into the ocean
 
 #else
Index: /branches/dev_003_CPL/NEMO/OPA_SRC/SBC/sbcblk_core.F90
===================================================================
--- /branches/dev_003_CPL/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 990)
+++ /branches/dev_003_CPL/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 991)
@@ -212,11 +212,9 @@
       !!      fields read in sbc_read
       !! 
-      !! ** Outputs : - utau    : i-component of the stress at U-point  (N/m2)
-      !!              - vtau    : j-component of the stress at V-point  (N/m2)
-      !!              - qsr     : Solar heat flux over the ocean        (W/m2)
-      !!              - qns     : Non Solar heat flux over the ocean    (W/m2)
-      !!              - evap    : Evaporation over the ocean            (kg/m2/s)
-      !!              - tprecip : Total precipitation                   (Kg/m2/s)
-      !!              - sprecip : Solid precipitation                   (Kg/m2/s)
+      !! ** Action  :   defined at each time-step at the air-sea interface
+      !!              - utau  &  vtau   : stress components in geographical ref.
+      !!              - qns   &  qsr    : non solar and solar heat fluxes
+      !!              - emp             : evap - precip (volume flux)
+      !!              - emps            : evap - precip (concentration/dillution)
       !!---------------------------------------------------------------------
       REAL(wp), INTENT(in), DIMENSION(jpi,jpj) ::   pst   ! surface temperature                      [Celcius]
Index: /branches/dev_003_CPL/NEMO/OPA_SRC/SBC/sbccpl.F90
===================================================================
--- /branches/dev_003_CPL/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 990)
+++ /branches/dev_003_CPL/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 991)
@@ -8,7 +8,7 @@
    !!            9.0   !  06-07  (G. Madec)  surface module
    !!----------------------------------------------------------------------
-#if defined key_sbc_cpl
-   !!----------------------------------------------------------------------
-   !!   'key_sbc_cpl'                   Coupled Ocean/Atmosphere formulation
+#if defined key_oasis3 || defined key_oasis4
+   !!----------------------------------------------------------------------
+   !!   'key_oasis3' or 'key_oasis4'   Coupled Ocean/Atmosphere formulation
    !!----------------------------------------------------------------------
    !!----------------------------------------------------------------------
@@ -16,87 +16,44 @@
    !!   sbc_cpl      : coupled formulation for the ocean surface boundary condition
    !!----------------------------------------------------------------------
-   USE oce             ! ocean dynamics and tracers
+
    USE dom_oce         ! ocean space and time domain
-   USE phycst          ! physical constants
+   USE sbc_oce         ! Surface boundary condition: ocean fields
+   USE sbc_ice         ! Surface boundary condition: ice fields
+#if defined key_lim3
+   USE par_ice          ! ice parameters
+#endif
+   USE cpl_oasis3      ! OASIS3 coupling (to ECHAM5)
+   USE geo2ocean
+   USE restart
    USE in_out_manager  ! I/O manager
+   USE iom             ! NetCDF library
    USE lib_mpp         ! distribued memory computing library
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE daymod          ! calendar
-
-   USE cpl_oasis3      ! OASIS3 coupling (to ECHAM5)
-   USE cpl_oasis4      ! OASIS4 coupling (to ECHAM5)
-   USE geo2ocean, ONLY : repere, repcmo
-   USE ice_2, only     : frld       ! : leads fraction = 1-a/totalarea
-
-   USE sbc_oce         ! Surface boundary condition: ocean fields
-
-   USE iom             ! NetCDF library
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   sbc_cpl       ! routine called by step.F90
-
-   LOGICAL, PUBLIC ::   lk_sbc_cpl = .TRUE.   !: coupled formulation flag
-
-   INTEGER , PARAMETER                 ::   jpfld   = 5    ! maximum number of files to read 
-   INTEGER , PARAMETER                 ::   jp_taux = 1    ! index of wind stress (i-component) file
-   INTEGER , PARAMETER                 ::   jp_tauy = 2    ! index of wind stress (j-component) file
-   INTEGER , PARAMETER                 ::   jp_qtot = 3    ! index of total (non solar+solar) heat file
-   INTEGER , PARAMETER                 ::   jp_qsr  = 4    ! index of solar heat file
-   INTEGER , PARAMETER                 ::   jp_emp  = 5    ! index of evaporation-precipation file
+   PUBLIC   sbc_cpl_snd       ! routine called by step.F90
    
-!!wonsun         
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   &
-      taux, tauy       &  !: surface stress components in (i,j) referential
-
-
-   USE sbc_ice, only : dqns_ice , & ! : derivative of non solar heat flux on sea ice
-                       qsr_ice  , & ! : solar flux over ice
-                       qns_ice  , & ! : total non solar heat flux (Longwave downward radiation) over ice
-                       tn_ice   , & ! : ice surface temperature
-                       alb_ice  , & ! : albedo of ice
-                       sprecip  , & ! : solid (snow) precipitation over water (!) what about ice?
-                       tprecip  , & ! : total precipitation ( or liquid precip minus evaporation in coupled mode)
-                       calving  , & ! : calving
-                       rrunoff  , & ! : monthly runoff (kg/m2/s)
-                       fr1_i0   , & ! : 1st part of the fraction of sol.rad. which penetrate inside the ice cover
-                       fr2_i0       ! : 2nd part of the fraction of sol.rad. which penetrate inside the ice cover
-
-   USE ice_2, only  : hicif ,     & ! : ice thickness
-                      frld  ,     & ! : leads fraction = 1-a/totalarea
-                      hsnif  ,    & ! : snow thickness
-                      u_ice , v_ice ! : ice velocity
-
-   USE sbc_oce, only : sst_m        ! : sea surface temperature
-
-   REAL(wp), PUBLIC ::            & !!! surface fluxes namelist (namflx)
-      q0    = 0.e0,               &  ! net heat flux
-      qsr0  = 0.e0,               &  ! solar heat flux
-      emp0  = 0.e0,               &  ! net freshwater flux
-      dqdt0 = -40.,               &  ! coefficient for SST damping (W/m2/K)
-      deds0 = 27.7                   ! coefficient for SSS damping (mm/day)
+   TYPE ::   FLD_CPL     ! Coupling Namelist field informations
+      LOGICAL            ::   laction   ! 
+      CHARACTER(len = 8) ::   clname      ! 
+      CHARACTER(len = 1) ::   clgrid      !
+      INTEGER            ::   nsgn      !
+   END TYPE FLD_CPL
    
-    REAL(wp), DIMENSION(jpi,jpj) ::   qsr_oce_recv , qsr_ice_recv 
-    REAL(wp), DIMENSION(jpi,jpj) ::   qns_oce_recv, qns_ice_recv
-    REAL(wp), DIMENSION(jpi,jpj) ::   dqns_ice_recv
-    REAL(wp), DIMENSION(jpi,jpj) ::   tprecip_recv , precip_recv
-    REAL(wp), DIMENSION(jpi,jpj) ::   fr1_i0_recv  , fr2_i0_recv     
-    REAL(wp), DIMENSION(jpi,jpj) ::   rrunoff_recv , calving_recv   
-#if defined key_cpl_ocevel
-    REAL(wp), DIMENSION(jpi,jpj) :: un_weighted, vn_weighted
-    REAL(wp), DIMENSION(jpi,jpj) :: un_send    , vn_send 
-#endif
-    REAL(wp), DIMENSION(jpi,jpj) :: zrunriv   ! river discharge into ocean
-    REAL(wp), DIMENSION(jpi,jpj) :: zruncot   ! continental discharge into ocean
-
-    REAL(wp), DIMENSION(jpi,jpj) :: zpew      ! P-E over water
-    REAL(wp), DIMENSION(jpi,jpj) :: zpei      ! P-E over ice
-    REAL(wp), DIMENSION(jpi,jpj) :: zpsol     ! surface downward snow fall
-    REAL(wp), DIMENSION(jpi,jpj) :: zevice    ! surface upward snow flux where sea ice
-!!wonsun         
-
-   !! * Substitutions
-#  include "domzgr_substitute.h90"
+
+   TYPE(FLD_CPL):: sn_snd_fice
+
+
+
+
+
+
+   REAL(wp), DIMENSION(jpi,jpj) :: qsr_mix
+
+
+
+
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL (2006) 
